/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Geo2Geo.h"

void
Geo2GeoGen (struct GEO GeoA, struct GEO *pGeoB)
{
  Geo2GeoVerQty (GeoA, pGeoB);
  Geo2GeoEdgeQty (GeoA, pGeoB);
  Geo2GeoFaceQty (GeoA, pGeoB);
  Geo2GeoPolyQty (GeoA, pGeoB);

  return;
}

/* Geo2Geotializing the properties of the vertices */
void
Geo2GeoVer (struct GEO GeoA, struct GEO *pGeoB)
{
  /*LineHeader(-1); printf("VerCoo\n"); */
  Geo2GeoVerCoo (GeoA, pGeoB);
  /*LineHeader(-1); printf("VerEdge\n"); */
  Geo2GeoVerEdge (GeoA, pGeoB);
  /*LineHeader(-1); printf("VerBound\n"); */
  Geo2GeoVerBound (GeoA, pGeoB);
  /*LineHeader(-1); printf("VerState\n"); */
  Geo2GeoVerState (GeoA, pGeoB);

  return;
}

/* Geo2Geotializing the properties of the edges */
void
Geo2GeoEdge (struct GEO GeoA, struct GEO *pGeoB)
{
  /*LineHeader(-1); printf("Geo2GeoEdgeVerNb\n"); */
  Geo2GeoEdgeVerNb (GeoA, pGeoB);
  /*LineHeader(-1); printf("Geo2GeoEdgeFace\n"); */
  Geo2GeoEdgeFace (GeoA, pGeoB);
  /*LineHeader(-1); printf("Geo2GeoEdgeLength\n"); */
  Geo2GeoEdgeLength (GeoA, pGeoB);
  Geo2GeoEdgeDel (GeoA, pGeoB);
  Geo2GeoEdgeState (GeoA, pGeoB);

  return;
}

/* Geo2Geotializing the properties of the faces */
void
Geo2GeoFace (struct GEO GeoA, struct GEO *pGeoB, int alloc)
{
  Geo2GeoFacePoly (GeoA, pGeoB);
  Geo2GeoFaceVer (GeoA, pGeoB, alloc);
  Geo2GeoFaceEdge (GeoA, pGeoB, alloc);
  Geo2GeoFaceFF (GeoA, pGeoB);
  Geo2GeoFaceEq (GeoA, pGeoB);
  Geo2GeoFaceBound (GeoA, pGeoB);
  Geo2GeoFaceState (GeoA, pGeoB);
  Geo2GeoFacePt (GeoA, pGeoB);

  return;
}

/* Geo2Geotializing the properties of the polyhedra */
void
Geo2GeoPoly (struct GEO GeoA, struct GEO *pGeoB, int alloc)
{
  Geo2GeoPolyFace (GeoA, pGeoB, alloc);

  return;
}

/* Geo2Geotializing the properties of the domain */
void
Geo2GeoDomain (struct GEO GeoA, struct GEO *pGeoB, int alloc)
{
  Geo2GeoDomainSize (GeoA, pGeoB, alloc);

  return;
}
