/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"DeleteEdge.h"

int
DeleteEdge (struct GEO *pGeo, struct IN In,
	    int edge, int *pver, double *pmaxff, int *pDelId)
{
  int delver, test;

  (*pDelId)++;

  if (In.verbosity >= 2)
    printf ("\ndeleting edge %5d (%5d) ------------------------------\n",
	    edge, *pDelId);

  UpdateEdgeState (pGeo, edge);
  (*pGeo).EdgeDel[edge] = 1;

  SearchDelNNewVer (pGeo, edge, &delver, pver);

  /* UpdateFace updates the properties of the parent faces
   * of the edge and more generally of delver. */
  UpdateFaceVerNEdge (pGeo, edge, delver, *pver, In.verbosity);

  UpdateVer (pGeo, edge, delver, *pver, In.verbosity);

  UpdateEdgeVerNb (pGeo, delver, *pver, In.verbosity);

  UpdateVerCoo (pGeo, delver, *pver, In.verbosity);

  UpdateEdgeLength (pGeo, *pver);
  
  UpdateFaceBound (pGeo, *pver);

  if (In.verbosity >= 2)
    ut_print_message (0, 3, "Testing geometry ...\n");

  {
    test = neut_geo_testAroundVer2 (*pGeo, *pver, 0);

    if (test != 0)
      (*pmaxff) = 888.8;
    else
    {
      if (In.verbosity >= 2)
	ut_print_message (0, 3, "Updating face flatness faults.\n");
      (*pmaxff) = UpdateFaceFF (pGeo, *pver);
    }
  }

  if (In.verbosity >= 2)
  {
    ut_print_lineheader (0);
    printf ("maxff=%.2f\n", (*pmaxff));
  }
  
  /*
  for (i = 1; i <= (*pGeo).EdgeQty; i++)
  {
    printf ("edge %d state = %d\n", i, (*pGeo).EdgeState[i]);
    if ((*pGeo).EdgeState[i] == 0)
    {
      ver1 = (*pGeo).EdgeVerNb[i][0];
      ver2 = (*pGeo).EdgeVerNb[i][1];

      ut_array_1d_memcpy (coo1, 3, (*pGeo).VerCoo[ver1]);
      ut_array_1d_memcpy (coo2, 3, (*pGeo).VerCoo[ver2]);

      (*pGeo).EdgeLength[i] = ut_space_dist (coo1, coo2);
    }
  }
  */

  return test;
}
