/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "SearchNSets.h"

void
SearchNSets (struct NODES Nodes, struct MESH Mesh2D, int nset,
             int** FoD, struct NSET* pNSets)
{
  // int *** pNSets, char*** pNSetNames)
  (*pNSets).names = ut_alloc_2d_char (45, 10);

  sprintf ((*pNSets).names[1], "x0");
  sprintf ((*pNSets).names[2], "x1");
  sprintf ((*pNSets).names[3], "y0");
  sprintf ((*pNSets).names[4], "y1");
  sprintf ((*pNSets).names[5], "z0");
  sprintf ((*pNSets).names[6], "z1");
  sprintf ((*pNSets).names[7], "y0z0");
  sprintf ((*pNSets).names[8], "y1z0");
  sprintf ((*pNSets).names[9], "y0z1");
  sprintf ((*pNSets).names[10], "y1z1");
  sprintf ((*pNSets).names[11], "x0z0");
  sprintf ((*pNSets).names[12], "x0z1");
  sprintf ((*pNSets).names[13], "x1z0");
  sprintf ((*pNSets).names[14], "x1z1");
  sprintf ((*pNSets).names[15], "x0y0");
  sprintf ((*pNSets).names[16], "x1y0");
  sprintf ((*pNSets).names[17], "x0y1");
  sprintf ((*pNSets).names[18], "x1y1");
  sprintf ((*pNSets).names[19], "x0y0z0");
  sprintf ((*pNSets).names[20], "x1y0z0");
  sprintf ((*pNSets).names[21], "x0y1z0");
  sprintf ((*pNSets).names[22], "x1y1z0");
  sprintf ((*pNSets).names[23], "x0y0z1");
  sprintf ((*pNSets).names[24], "x1y0z1");
  sprintf ((*pNSets).names[25], "x0y1z1");
  sprintf ((*pNSets).names[26], "x1y1z1");
  sprintf ((*pNSets).names[27], "x0body");
  sprintf ((*pNSets).names[28], "x1body");
  sprintf ((*pNSets).names[29], "y0body");
  sprintf ((*pNSets).names[30], "y1body");
  sprintf ((*pNSets).names[31], "z0body");
  sprintf ((*pNSets).names[32], "z1body");
  sprintf ((*pNSets).names[33], "y0z0body");
  sprintf ((*pNSets).names[34], "y1z0body");
  sprintf ((*pNSets).names[35], "y0z1body");
  sprintf ((*pNSets).names[36], "y1z1body");
  sprintf ((*pNSets).names[37], "x0z0body");
  sprintf ((*pNSets).names[38], "x0z1body");
  sprintf ((*pNSets).names[39], "x1z0body");
  sprintf ((*pNSets).names[40], "x1z1body");
  sprintf ((*pNSets).names[41], "x0y0body");
  sprintf ((*pNSets).names[42], "x1y0body");
  sprintf ((*pNSets).names[43], "x0y1body");
  sprintf ((*pNSets).names[44], "x1y1body");

  if (nset == 0)
    (*pNSets).qty = 0;
  else if (nset == 1)
    (*pNSets).qty = 6;
  else if (nset == 2)
    (*pNSets).qty = 26;
  else if (nset >= 3)
    (*pNSets).qty = 44;

  if ((*pNSets).qty == 0)
    (*pNSets).nodes = NULL;
  else
    (*pNSets).nodes = ut_alloc_1d_pint ((*pNSets).qty + 1);

  if (nset > 0)
  {
    if (FoD != NULL && Mesh2D.EltQty > 0)
      neut_fod_fodnodes (FoD, Mesh2D, (*pNSets).nodes);
    else
    {
      ut_print_messagewnc (1, 72, "Mesh skin information not available.  Assuming brick-shape domain to generate nsets."); 
      neut_nodes_fodnodes (Nodes, (*pNSets).nodes);
    }
  }
  if (nset >= 2)
  {
    neut_fodnodes_eodnodes ((*pNSets).nodes, (*pNSets).nodes + 6);
    neut_eodnodes_codnodes ((*pNSets).nodes + 6, (*pNSets).nodes + 18);
  }
  if (nset >= 3)
  {
    neut_fodnodes_fodbnodes ((*pNSets).nodes, (*pNSets).nodes + 6, (*pNSets).nodes + 26);
    neut_eodnodes_eodbnodes ((*pNSets).nodes + 6, (*pNSets).nodes +18, (*pNSets).nodes + 32);
  }

  return;
}


void
neut_nset_set_zero (struct NSET* pNSet)
{
  (*pNSet).qty = 0;
  (*pNSet).names = NULL;
  (*pNSet).nodes = NULL;

  return;
}

void
neut_nset_free (struct NSET* pNSet)
{
  ut_free_2d_char ((*pNSet).names, 45);
  ut_free_2d_int  ((*pNSet).nodes, 45);

  return;
}
