/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"WriteMeshAbq.h"

void
neut_mesh_fprintf_abq_nsets (FILE* file, char* nset, int** NSets, char** NSetNames)
{
  int i, j;
  char** name;
  int qty;

  ut_string_separate (nset, ',', &name, &qty);

  for (i = 0; i < qty; i++)
    for (j = 1; j <= 44; j++)
      if (strcmp (name[i], NSetNames[j]) == 0)
      {
	neut_mesh_fprintf_abq_nset (file, NSetNames[j], NSets[j]);
	break;
      }
  
  ut_free_2d_char (name, qty);

  return;
}

void
neut_mesh_fprintf_abq_nset (FILE* file, char* name, int* nodeset)
{
  int i, col;

  fprintf (file, "\n*Nset, nset=%s\n", name);

  col = 0;
  for (i = 1; i < nodeset[0]; i++)
    ut_print_wnc (file, &col, 72, "%d, ", nodeset[i]);
  ut_print_wnc (file, &col, 72, "%d\n", nodeset[nodeset[0]]);

  return;
}
