/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_mm.h"

void
TreatArg_mm (int fargc, char **fargv, int argc, char **argv,
	     struct IN *pIn, struct DNEIGH *pDNeigh)
{
  SetDefaultOptions_mm (pIn, pDNeigh);

  /* Reading options. */
  SetOptions_mm (pIn, pDNeigh, fargc, fargv);
  SetOptions_mm (pIn, pDNeigh, argc, argv);

  /* Checking the input options */
  if ((*pIn).input == -1)
    ut_arg_badarg ();

  if ((*pIn).input == 1)
  {				
    if ((*pDNeigh).Id != -1)
    {
      printf ("id    = %d (should be != -1)\n",  (*pDNeigh).Id);
      ut_arg_badarg ();
    }

    if (ut_file_exist ((*pIn).ingeo) == 0)	/* and the file must exist. */
      ut_file_open ((*pIn).ingeo, "r");
  }

  if ((*pIn).input == 2)
  {
    net_n1d_morpho_n ((*pDNeigh).N1d, (*pDNeigh).morpho, &((*pDNeigh).N));
    (*pDNeigh).NDensity = (*pDNeigh).N;
  }

  if ((*pDNeigh).ttype != 2 && ((*pIn).nsitesize > 0 || (*pIn).nsite != 0))
  {
    ut_print_messagewnc (2, 72,
		"  `-nsiteXXX' options are forbidden with -ttype != 2. Maybe you should use -ttype 2?");
    abort ();
  }

  /* Writing file names */
  if ((*pIn).body == NULL)
  {
    (*pIn).body = ut_alloc_1d_char (1000);

    if ((*pIn).ingeo != NULL)
      ut_string_body ((*pIn).ingeo, (*pIn).body);
    else if ((*pIn).input == 2)
      sprintf ((*pIn).body, "%s%d", (*pDNeigh).morpho, (*pDNeigh).N1d);
    else if ((*pDNeigh).Id != -1)
      sprintf ((*pIn).body, "n%d-id%d", (*pDNeigh).NDensity, (*pDNeigh).Id);
    else
      sprintf ((*pIn).body, "n%d-rand", (*pDNeigh).NDensity);
  }

  (*pIn).msh = ut_string_addextension ((*pIn).body, ".msh");
  (*pIn).geof = ut_string_addextension ((*pIn).body, ".geof");
  (*pIn).abq = ut_string_addextension ((*pIn).body, ".inp");
  (*pIn).oin = ut_string_addextension ((*pIn).body, ".oin");
  (*pIn).nsitefile = ut_string_addextension ((*pIn).body, ".nsite");

  return;
}
