/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RMeshingFNId.h"

void
RMeshingFNId (struct IN In, struct MESH* pMesh, struct DNEIGH *pDNeigh)
{
  int i, j;
  struct GERMSET GermSet;
  double* size = ut_alloc_1d (7);
  size[2] = size[4] = size[6] = 1;
  double** domainsize = ut_alloc_2d (3, 2);
  domainsize[0][1] = 1;
  domainsize[1][1] = 1;
  domainsize[2][1] = 1;

  (*pDNeigh).Size = ut_alloc_1d (7);
  (*pDNeigh).Size[1] = (*pDNeigh).Size[3] = (*pDNeigh).Size[5] = 0;
  (*pDNeigh).Size[2] = (*pDNeigh).Size[4] = (*pDNeigh).Size[6] = 1;
  (*pDNeigh).Vol = 1;

  // Setting germs coo
  (*pDNeigh).Random = neut_rand_nnid2rand ((*pDNeigh).NDensity, (*pDNeigh).Id);

  // N
  if ((*pDNeigh).ttype == 0 || (*pDNeigh).ttype == 1
   || (*pDNeigh).ttype == 3)
  {
    (*pDNeigh).N = (*pDNeigh).NDensity;
  }
  else if ((*pDNeigh).ttype == 2)
    (*pDNeigh).N =
      neut_rand_poisson ((*pDNeigh).NDensity, (int) (*pDNeigh).Random, 1);
  else
    abort ();

  // GermsCoo inside the domain
  (*pDNeigh).GermsCoo = ut_alloc_2d ((*pDNeigh).N + 1, 4);

  if (strcmp ((*pDNeigh).morpho, "poisson") == 0)
    IniGermsCoo ((*pDNeigh).morpho, (*pDNeigh).N, (*pDNeigh).Random,
		 (*pDNeigh).Size, (*pDNeigh).GermsCoo);
  else if (strcmp ((*pDNeigh).morpho, "custom") == 0)
    DistribFromFile (In.centrecoo, (*pDNeigh).N, &((*pDNeigh).GermsCoo));
  else 
  {
    GermSet.N1d = (*pDNeigh).N1d;

    if (strcmp ((*pDNeigh).morpho, "cube") == 0)
      CubeDistrib (&GermSet, size);
    else if (strcmp ((*pDNeigh).morpho, "tocta") == 0)
      TruOctaDistrib (&GermSet, size);
    else
      abort ();

    (*pDNeigh).GermsCoo = ut_alloc_2d ((*pDNeigh).N + 1, 4);
    for (i = 1; i <= (*pDNeigh).N; i++)
      for (j = 1; j <= 3; j++)
        (*pDNeigh).GermsCoo[i][j] = GermSet.GermsCoo[i][j];

    ut_free_2d (GermSet.GermsCoo, (*pDNeigh).N + 1);
  }

  DefDNeigh (pDNeigh);

  // Searching elt poly
  int* msize = ut_alloc_1d_int (3);
  nemm_in_msize (In, domainsize, msize);
  NIdSearchEltPoly (msize, pDNeigh, pMesh);

  ut_free_1d (size);
  ut_free_1d_int (msize);
  ut_free_2d (domainsize, 3);

  return;
}
