/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RMeshingFNId.h"

void
NIdSearchEltPoly (int* msize, struct DNEIGH *pDNeigh, struct MESH* pMesh)
{
  int i, elt;
  int Germ;
  double dist;

  int EltQty = msize[0] * msize[1] * msize[2];

  double* GermDist = ut_alloc_1d ((*pDNeigh).N + (*pDNeigh).nN + 1);

  GermDist[0] = 1e30;	/* This is to avoid id 0 in the */
  /* minimum searching below.     */

  /* for every elt, the poly of which it belongs is searched out. */
  for (elt = 1; elt <= EltQty; elt++)
  {
    /* calculation of the distances bw the elt and the germs
     * (GermsCoo...+1 for memory skip)
     */
    for (i = 1; i <= (*pDNeigh).N; i++)
    {
      dist = ut_space_dist ((*pMesh).EltCoo[elt], (*pDNeigh).GermsCoo[i] + 1);
      GermDist[i] = dist;
    }
    for (i = 1; i <= (*pDNeigh).nN; i++)
    {
      dist = ut_space_dist ((*pMesh).EltCoo[elt], (*pDNeigh).nGermsCoo[i] + 1);
      GermDist[(*pDNeigh).N + i] = dist;
    }

    /* recording of the id of the nearest seed  */
    Germ = ut_array_1d_min_index (GermDist, (*pDNeigh).N + (*pDNeigh).nN + 1);

    (*pMesh).EltElset[elt] = Germ;

    /* print percent evolution in case of verbosity */
    // PercentDisplay (elt, EltQty, 10, &m);
  }

  ut_free_1d (GermDist);

  /* If the tessellation is periodic */
  /* applying GermtoGerm on EltPoly */
  if ((*pDNeigh).ttype == 1)
    for (elt = 1; elt <= EltQty; elt++)
    {
      Germ = (*pMesh).EltElset[elt];

      if (Germ >= (*pDNeigh).N + 1)	/* modifying Germ */
      {
	Germ = (*pDNeigh).GermToGerm[Germ - (*pDNeigh).N];
	(*pMesh).EltElset[elt] = Germ;
      }
    }

  return;
}
