/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_mm.h"

void
Res_mm (
	 struct IN In, struct NODES Nodes, struct MESH Mesh,
	 int** FoDNodes, struct DNEIGH DNeigh)
{
  int *PolyEltQty = NULL;
  /* [0]: real nb of polys (ie that have elements) */
  /* [i]: nb of elts of poly i */

  FILE *file = NULL;
  char *expandnset = NULL;
  char *expandfaset = NULL;

  neut_utils_nset_expand (In.nset, &expandnset);
  neut_utils_nset_expand (In.faset, &expandfaset);

  CalcPolyEltQty (Mesh, DNeigh, &PolyEltQty);

  if (strlen (In.format) > 0)
    ut_print_message (0, 2, "Writing mapped mesh ...\n");

  if (ut_string_inlist (In.format, ',', "geof"))
  {
    file = ut_file_open (In.geof, "w");
    WriteMapMeshGeof (In, expandnset, expandfaset,
		   Nodes, Mesh, FoDNodes, file);
    ut_file_close (file, In.geof, "w");
  }
  
  if (ut_string_inlist (In.format, ',', "abq")
   || ut_string_inlist (In.format, ',', "inp"))
  {
    file = ut_file_open (In.abq, "w");
    WriteMapMeshAbq (In, expandnset, expandfaset,
		   Nodes, Mesh, FoDNodes, file);
    ut_file_close (file, In.abq, "w");
  }

  if (ut_string_inlist (In.format, ',', "msh"))
  {
    file = ut_file_open (In.msh, "w");
    WriteMapMeshGmsh (expandnset, expandfaset,
		   Nodes, Mesh, FoDNodes, file);
    ut_file_close (file, In.msh, "w");
  }

  file = ut_file_open (In.oin, "w");
  net_oin_fprintf_dneigh (file, DNeigh, PolyEltQty);
  ut_file_close (file, In.oin, "w");
  // WriteOriIn (In, DNeigh, PolyEltQty);


  ut_free_1d_int (PolyEltQty);

  return;
}
