/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"neper_mm.h"

int
neper_mm (int fargc, char **fargv, int argc, char **argv)
{
  struct IN In;
  struct DNEIGH DNeigh;
  struct NODES Nodes;
  struct MESH Mesh;
  int **FoDNodes;


  neut_mesh_set_zero (&Mesh);
  neut_nodes_set_zero (&Nodes);

  ut_print_moduleheader ("-MM", fargc, fargv, argc, argv);

  InputData_mm (&In, &DNeigh, fargc, fargv, argc, argv);

  ut_print_message (0, 1, "Mapped meshing ...\n");

  RMeshing (&Nodes, &Mesh, &FoDNodes, In, &DNeigh);


  Res_mm (In, Nodes, Mesh, FoDNodes, DNeigh);

  neut_mesh_free (&Mesh);
  neut_nodes_free (&Nodes);

  return 0;
}
