/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RandDistrib.h"

/* IniVariables initializes the program variables related to the 
 * previously loaded input data and internal parameters. They are
 * described in the mp.h file. */
void
RandDistrib (struct GERMSET *pGermSet, double *size)
{
  /* Initializing the variable: Random */
  (*pGermSet).Random = neut_rand_nnid2rand ((*pGermSet).N, (*pGermSet).Id);

  if ((*pGermSet).ttype == 2)
  {
    (*pGermSet).NDensity = (*pGermSet).N;
    (*pGermSet).N =
      neut_rand_poisson ((double) (*pGermSet).NDensity, (int) (*pGermSet).Random, 1);
  }

  /* IniGermsCoo initializes the variable: GermsCoo */
  (*pGermSet).GermsCoo = ut_alloc_2d ((*pGermSet).N + 1, 4);

  IniGermsCoo ((*pGermSet).morpho, (*pGermSet).N, (*pGermSet).Random,
	       size, (*pGermSet).GermsCoo);

  return;
}

void
DistribFromFile (char* filename, int N, double*** pGermsCoo)
{
  FILE *file = ut_file_open (filename, "r");
  int i, j;

  (*pGermsCoo) = ut_alloc_2d (N + 1, 4);

  for (i = 1; i <= N; i++)
    for (j = 1; j <= 3; j++)
      fscanf (file, "%lf", &((*pGermsCoo)[i][j]));

  ut_file_close (file, filename, "r");

  return;
}
