/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_t.h"

void
InputData_t (struct IN *pIn, struct GERMSET *pGermSet,
	     int fargc, char **fargv, int argc, char **argv)
{
  TreatArg_t (fargc, fargv, argc, argv, pIn, pGermSet);

  return;
}

void
net_in_free (struct IN In)
{
  ut_free_1d (In.size);
  ut_free_1d (In.F);
  ut_free_1d_char (In.format);
  ut_free_1d_char (In.body);
  ut_free_1d_char (In.load);
  ut_free_1d_char (In.geo);
  ut_free_1d_char (In.gmshgeo);
  ut_free_1d_char (In.oin);
  ut_free_1d_char (In.mast);
  ut_free_1d_char (In.asy);
  ut_free_1d_char (In.centrecoo);
  ut_free_1d_char (In.stt3);
  ut_free_1d_char (In.stt0);
  ut_free_2d_char (In.sorttess, In.sorttess_qty);

  return;
}


void
net_germset_free (struct GERMSET GermSet)
{
  ut_free_1d_char (GermSet.morpho);
  ut_free_2d (GermSet.GermsCoo, GermSet.N + 1);

  return;
}
