/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Miscellaneous.h"

void
DefDNeigh (struct DNEIGH *pDNeigh)
{
  if ((*pDNeigh).ttype == 0)
  {
    (*pDNeigh).nSize = (*pDNeigh).Size;
    (*pDNeigh).nVol = 0;
    (*pDNeigh).nN = 0;
    (*pDNeigh).nGermsCoo = NULL;

    (*pDNeigh).nGermRandId = NULL;
  }
  else if ((*pDNeigh).ttype == 1)
  {
    DNeighSize (pDNeigh);
    DNeighGermsPer (pDNeigh);
  }
  else if ((*pDNeigh).ttype == 2)
  {
    if ((*pDNeigh).N != 0)
    {
      DNeighSize (pDNeigh);
      DNeighGermsSD (pDNeigh);
    }
    else
      DNeigh4EmpD (pDNeigh);
  }
  else
    abort ();

  return;
}

void
CreateTess (struct GERMSET GermSet, double *Size, struct TESS *pTess)
{
  struct INTEPARA IntePara;
  struct POLY Domain;
  struct POLY *Poly;
  struct POLYMOD Polymod;

  InternalPara (&IntePara);
  CubeDomain (Size, &Domain);
  PolyComp (&IntePara, Domain, GermSet, &Polymod, &Poly, 0);
  Tessellation (GermSet, Poly, pTess);

  return;
}

void
net_n1d_morpho_n (int n1d, char* morpho, int* pn)
{
  if (strcmp (morpho, "cube") == 0)
    (*pn) = n1d * n1d * n1d;
  else if (strcmp (morpho, "tocta") == 0)
    (*pn) =   (n1d - 1) * (n1d - 1) * (n1d - 1) + n1d * n1d * n1d;

  return;
}
