/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "net_oin.h"

int
net_oin_fprintf (FILE* file, struct GERMSET GermSet, int* id)
{
  int i;

  fprintf (file, "%s\n", GermSet.morpho);
  if (strcmp  (GermSet.morpho, "poisson")     == 0
   || strcmp  (GermSet.morpho, "equiaxed")    == 0
   || strncmp (GermSet.morpho, "columnar", 8) == 0
   || strncmp (GermSet.morpho, "bamboo"  , 6) == 0
   || strcmp  (GermSet.morpho, "custom")      == 0)
    fprintf (file, "%d %d %d\n", GermSet.N, GermSet.Id, GermSet.N);
  else if (strcmp (GermSet.morpho, "cube") == 0
        || strcmp (GermSet.morpho, "dodeca") == 0
        || strcmp (GermSet.morpho, "tocta") == 0)
    fprintf (file, "%d %d %d\n", GermSet.N1d, GermSet.Id, GermSet.N);
  else
    abort ();

  if (id == NULL)
    fprintf (file, "continuous\n");
  else
  {
    fprintf (file, "list\n");
    for (i = 1; i <= GermSet.N; i++)
      fprintf (file, "%d\n", id[i]);
  }

  return 0;
}

int
net_oin_fprintf_dneigh (FILE* file, struct DNEIGH DNeigh, int* PolyEltQty)
{
  int i;
  int m = 0;

  fprintf (file, "%s\n", DNeigh.morpho);
  if (strcmp (DNeigh.morpho, "poisson") == 0)
    fprintf (file, "%d %d %d\n", DNeigh.NDensity, DNeigh.Id, PolyEltQty[0]);
  else if (strcmp (DNeigh.morpho, "cube") == 0
        || strcmp (DNeigh.morpho, "dodeca") == 0
        || strcmp (DNeigh.morpho, "tocta") == 0)
    fprintf (file, "%d %d %d\n", DNeigh.N1d, DNeigh.Id, DNeigh.N);
  else if (strcmp (DNeigh.morpho, "custom") == 0)
    fprintf (file, "%d %d %d\n", DNeigh.N, DNeigh.Id, DNeigh.N);
  else 
    abort ();

  for (i = 1; i <= DNeigh.N; i++)
    if (PolyEltQty[i] != 0)
      FPrintfWNC (file, i, &m, 72);
  for (i = 1; i <= DNeigh.nN; i++)      /* else, it must not be printed. */
    if (PolyEltQty[i + DNeigh.N] != 0)  /* the same... */
      FPrintfWNC (file, DNeigh.nGermRandId[i], &m, 72);

  return 0;
}
