/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"nevs_camera.h"

void
nevs_camera_init (struct GEO Geo, struct NODES Nodes,
             struct MESH Mesh, struct PRINT* pPrint)
{
  if ((*pPrint).cameracooinit == 0)
  {
    if ((*pPrint).showelt[0] != -1)
      nevs_camera_coo ("meshcentre+v", Geo, Nodes, Mesh, pPrint, 0);
    else if ((*pPrint).showpoly[0] != -1)
      nevs_camera_coo ("tesscentre+v", Geo, Nodes, Mesh, pPrint, 0);
  }

  if ((*pPrint).cameralookatinit == 0)
  {
    if ((*pPrint).showelt[0] != -1)
      nevs_camera_lookat ("meshcentre", Geo, Nodes, Mesh, pPrint, 0);
    else if ((*pPrint).showpoly[0] != -1)
      nevs_camera_lookat ("tesscentre", Geo, Nodes, Mesh, pPrint, 0);
  }

  return;
}

void
nevs_camera (char** argv, int* pi, struct GEO Geo, struct NODES Nodes,
             struct MESH Mesh, struct PRINT* pPrint)
{
  if (strcmp (argv[*pi], "-cameracoox") == 0)
    nevs_camera_coo (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 1);

  else if (strcmp (argv[*pi], "-cameracooy") == 0)
    nevs_camera_coo (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 2);

  else if (strcmp (argv[*pi], "-cameracooz") == 0)
    nevs_camera_coo (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 3);

  else if (strcmp (argv[*pi], "-cameracoo") == 0)
  {
    (*pi)++;
    nevs_camera_coo (argv[*pi], Geo, Nodes, Mesh, pPrint, 1);
    nevs_camera_coo (argv[*pi], Geo, Nodes, Mesh, pPrint, 2);
    nevs_camera_coo (argv[*pi], Geo, Nodes, Mesh, pPrint, 3);
  }

  else if (strcmp (argv[*pi], "-cameralookatx") == 0)
    nevs_camera_lookat (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 1);

  else if (strcmp (argv[*pi], "-cameralookaty") == 0)
    nevs_camera_lookat (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 2);

  else if (strcmp (argv[*pi], "-cameralookatz") == 0)
    nevs_camera_lookat (argv[++(*pi)], Geo, Nodes, Mesh, pPrint, 3);

  else if (strcmp (argv[*pi], "-cameralookat") == 0)
  {
    (*pi)++;
    nevs_camera_lookat (argv[*pi], Geo, Nodes, Mesh, pPrint, 1);
    nevs_camera_lookat (argv[*pi], Geo, Nodes, Mesh, pPrint, 2);
    nevs_camera_lookat (argv[*pi], Geo, Nodes, Mesh, pPrint, 3);
  }

  else if (strcmp (argv[*pi], "-cameraangle") == 0)
    sscanf (argv[++(*pi)], "%lf", &((*pPrint).cameraangle));

  else
  {
    ut_print_message (2, 0, "Unknown command %s\n", argv[(*pi)]);
    abort ();
  }

  return;
}
