/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"neut_gmsh.h"

void
neut_gmsh_call (char *gmsh, char *arg)
{
  char command[1000];

  sprintf (command, "%s %s", gmsh, arg);
  system (command);

  return;
}

/* This is to deal with the default config file of gmsh. */
void
neut_gmsh_rc (char *action)
{
  char *s1 = ut_alloc_1d_char (1000);
  char *s2 = ut_alloc_1d_char (1000);

  sprintf (s1, "%s/.gmshrc", getenv ("HOME"));
  sprintf (s2, "%s.bak", s1);

  if (strcmp (action, "bak") == 0)
    rename (s1, s2);
  else if (strcmp (action, "unbak") == 0)
    rename (s2, s1);
  else
    abort ();

  ut_free_1d_char (s1);
  ut_free_1d_char (s2);

  return;
}

int
neut_gmsh_meshalgo2d_nb (char* algo, int* pnb)
{
  if (algo == NULL)
    (*pnb) = 0;
  else if (strcmp (algo, "none") == 0)
    (*pnb) = 0;
  else if (strcmp (algo, "mead") == 0)
    (*pnb) = 1;
  else if (strcmp (algo, "dela") == 0)
    (*pnb) = 5;
  else if (strcmp (algo, "fron") == 0)
    (*pnb) = 6;
  else
    (*pnb) = -1;

  return ((*pnb) < 0) ? -1: 0;
}

int
neut_gmsh_meshalgo3d_nb (char* algo, int* pnb)
{
  if (algo == NULL)
    (*pnb) = 0;
  else if (strcmp (algo, "none") == 0)
    (*pnb) = 0;
  else if (strcmp (algo, "dela") == 0)
    (*pnb) = 1;
  else if (strcmp (algo, "fron") == 0)
    (*pnb) = 4;
  else if (strcmp (algo, "netg") == 0)
    (*pnb) = 4;
  else
    (*pnb) = -1;

  return ((*pnb) < 0) ? -1: 0;
}

int
neut_gmsh_optialgo_nb (char* algo, int* pnb)
{
  if (algo == NULL)
    (*pnb) = 0;
  else if (strcmp (algo, "none") == 0)
    (*pnb) = 0;
  else if (strcmp (algo, "gmsh") == 0)
    (*pnb) = 1;
  else if (strcmp (algo, "netg") == 0)
    (*pnb) = 2;
  else if (strcmp (algo, "gmne") == 0)
    (*pnb) = 3;
  else
    (*pnb) = -1;

  return ((*pnb) < 0) ? -1: 0;
}


int
neut_gmsh_elt_nb (char* morpho, int dim, int order, int* pnb)
{
  if (strcmp (morpho, "tri") == 0)
  {
    if (     dim == 0 && order == 1)
      (*pnb) = 15;
    else if (dim == 0 && order == 2)
      (*pnb) = 15;
    else if (dim == 1 && order == 1)
      (*pnb) = 1;
    else if (dim == 1 && order == 2)
      (*pnb) = 8;
    else if (dim == 2 && order == 1)
      (*pnb) = 2;
    else if (dim == 2 && order == 2)
      (*pnb) = 9;
    else if (dim == 3 && order == 1)
      (*pnb) = 4;
    else if (dim == 3 && order == 2)
      (*pnb) = 11;
    else
      (*pnb) = -1;
  }
  else if (strcmp (morpho, "quad") == 0)
  {
    if (     dim == 0 && order == 1)
      (*pnb) = 15;
    else if (dim == 0 && order == 2)
      (*pnb) = 15;
    else if (dim == 1 && order == 1)
      (*pnb) = 1;
    else if (dim == 1 && order == 2)
      (*pnb) = 8;
    else if (dim == 2 && order == 1)
      (*pnb) = 3;
    else if (dim == 2 && order == 2)
      (*pnb) = 16;
    else if (dim == 3 && order == 1)
      (*pnb) = 5;
    else if (dim == 3 && order == 2)
      (*pnb) = 17;
    else
      (*pnb) = -1;
  }
  else
    (*pnb) = -1;

  return ((*pnb) > 0)? 0: -1;
}
