/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "neut_print.h"

void
neut_print_set_default (struct PRINT* pPrint)
{
  // camera ------------------------------------------------------------
  (*pPrint).cameracooinit = 0;
  (*pPrint).cameracooexpr = ut_alloc_1d_char (100);
  sprintf ((*pPrint).cameracooexpr, "meshcentre+v");
  (*pPrint).cameracoo     = ut_alloc_1d (3);

  (*pPrint).cameralookatinit = 0;
  (*pPrint).cameralookatexpr = ut_alloc_1d_char (100);
  sprintf ((*pPrint).cameralookatexpr, "meshcentre");
  (*pPrint).cameralookat = ut_alloc_1d (3);
  (*pPrint).cameraangle = 25;

  // image -------------------------------------------------------------
  (*pPrint).imagewidth  = 1200;
  (*pPrint).imageheight = 900;
  (*pPrint).imagebackground = ut_alloc_1d (3);
  ut_array_1d_set ((*pPrint).imagebackground, 3, 1);
  (*pPrint).imageantialias = 0;

  (*pPrint).eltedgerad = 0;
  (*pPrint).elt1dedgerad = 0;
  (*pPrint).edgerad = 0;

  (*pPrint).showinit = 0;
  (*pPrint).showtype = ut_alloc_1d_char (10);
  sprintf ((*pPrint).showtype, "elt");
  (*pPrint).showver   = ut_alloc_1d_int (1);
  (*pPrint).showedge  = ut_alloc_1d_int (1);
  (*pPrint).showface  = ut_alloc_1d_int (1);
  (*pPrint).showfaceinter = 0;
  (*pPrint).showpoly  = ut_alloc_1d_int (1);
  (*pPrint).showelt   = ut_alloc_1d_int (1);
  (*pPrint).showelt0d = ut_alloc_1d_int (1);
  (*pPrint).showelt1d = ut_alloc_1d_int (1);
  (*pPrint).showelt2d = ut_alloc_1d_int (1);
  (*pPrint).showver   [0] = -1;
  (*pPrint).showedge  [0] = -1;
  (*pPrint).showface  [0] = -1;
  (*pPrint).showpoly  [0] = -1;
  (*pPrint).showelt   [0] = -1;
  (*pPrint).showelt0d [0] = -1;
  (*pPrint).showelt1d [0] = -1;
  (*pPrint).showelt2d [0] = -1;

  (*pPrint).datareduction = 1;
  
  (*pPrint).format = ut_alloc_1d_char (10);
  sprintf ((*pPrint).format, "png");

  return;
}

void
neut_print_free (struct PRINT* pPrint)
{
  // camera ------------------------------------------------------------
  ut_free_1d_char ((*pPrint).cameracooexpr);
  ut_free_1d ((*pPrint).cameracoo);

  ut_free_1d_char ((*pPrint).cameralookatexpr);
  ut_free_1d ((*pPrint).cameralookat);

  // image -------------------------------------------------------------
  ut_free_1d ((*pPrint).imagebackground);
  ut_free_1d_char ((*pPrint).showtype);
  ut_free_1d_int ((*pPrint).showver);
  ut_free_1d_int ((*pPrint).showedge);
  ut_free_1d_int ((*pPrint).showface);
  ut_free_1d_int ((*pPrint).showpoly);
  ut_free_1d_int ((*pPrint).showelt);
  ut_free_1d_int ((*pPrint).showelt0d);
  ut_free_1d_int ((*pPrint).showelt1d);
  ut_free_1d_int ((*pPrint).showelt2d);
  
  ut_free_1d_char ((*pPrint).format);

  return;
}
