/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2011, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "neut_tess_fscanf.h"

/* Importation of the tessellation from a .des file.
 */
void
neut_tess_fscanf (FILE* file, struct TESS *pTess)
{
  TIHead (pTess, file);
  TIVer (pTess, file);
  TIEdge (pTess, file);
  TIFace (pTess, file);
  TIPoly (pTess, file);
  TIDomain (pTess, file);
  TIFoot (file);

  return;
}

void
neut_tess_name_fscanf (char* name, struct TESS *pTess)
{
  FILE* file = NULL;
 
  file = ut_file_open (name, "r");
  neut_tess_fscanf (file, pTess);
  ut_file_close (file, name, "r");

  return;
}
