/**********************************************************************
 * Orilib - routines for orientation manipulation.                    *
 * Copyright (C) 2007, 2008, 2009 Romain Quey                         *
 *                                                                    *
 * This program is free software: you can redistribute it and/or      *
 * modify it under the terms of the GNU General Public License as     *
 * published by the Free Software Foundation, either version 3 of the *
 * License, or (at your option) any later version.                    *
 *                                                                    *
 * This program is distributed in the hope that it will be useful,    *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
 * General Public License for more details.                           *
 *                                                                    *
 * You should have received a copy of the GNU General Public License  *
 * along with this program.  If not, see                              *
 * <http://www.gnu.org/licenses/>.                                    *
 *                                                                    *
 * project homepage: http://orilib.sourceforge.net                    *
 **********************************************************************/
#ifndef OL_DESx
#define OL_DESx

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include"../ut/ut.h"
#define isNaN(x) ((x) != (x))
#include "ol_glo.h"
#include "ol_cal.h"
#ifndef OL_R0_H
#define OL_R0_H

extern double* ol_R_alloc (void);
extern void ol_R_free (double *);
extern int ol_R_fscanf (FILE *, double *);
extern int ol_R_fprintf (FILE *, double *, char *);
extern void ol_g_R (double **, double *);
extern void ol_R_g (double *, double **);
extern void ol_rtheta_R (double *, double, double *);
extern void ol_rtheta_R_rad (double *, double, double *);
extern void ol_R_rtheta (double *, double *, double *);
extern void ol_R_rtheta_rad (double *, double *, double *);
extern void ol_R_r (double *, double *);
extern void ol_R_theta (double *, double *);
extern void ol_R_theta_rad (double *, double *);
extern void ol_R_memcpy (double *, double *);
extern void ol_R_set_zero (double *);
extern void ol_R_set_id (double *);
extern void ol_R_set_this (double *, double, double, double);
extern void ol_R_e (double *, double *);
extern void ol_R_e_rad (double *, double *);

#endif /* OL_R0_H */
#ifndef OL_E0_H
#define OL_E0_H

extern double* ol_e_alloc (void);
extern void ol_e_free (double *);
extern void ol_e_set_zero (double *);
extern void ol_e_set_id (double *);
extern void ol_e_set_this (double *, double, double, double);
extern void ol_e_memcpy (double *, double *);
extern void ol_g_e (double **, double *);
extern void ol_e_g (double *, double **);
extern void ol_e_g_rad (double *, double **);
extern void ol_g_e_rad (double **, double *);
extern void ol_e_e (double *, double *);
extern void ol_e_e_rad (double *, double *);
extern void ol_e_deg2rad (double *, double *);
extern void ol_e_rad2deg (double *, double *);
extern int ol_e_fscanf (FILE *, double *);
extern int ol_e_fprintf (FILE *, double *, char *);

extern void ol_e_R (double *, double *);
extern void ol_e_R_rad (double *, double *);
extern void ol_e_rtheta (double *, double *, double *);
extern void ol_e_rtheta_rad (double *, double *, double *);
extern void ol_e_r (double *, double *);
extern void ol_e_theta (double *, double *);
extern void ol_e_theta_rad (double *, double *);

extern void ol_e_er (double*, double*);
extern void ol_e_ek (double*, double*);
extern void ol_er_e (double*, double*);
extern void ol_ek_e (double*, double*);
extern void ol_e_er_rad (double*, double*);
extern void ol_e_ek_rad (double*, double*);
extern void ol_er_e_rad (double*, double*);
extern void ol_ek_e_rad (double*, double*);

#endif /* OL_E0_H */
#ifndef OL_G0_H
#define OL_G0_H

extern double** ol_g_alloc (void);
extern void ol_g_free (double **);
extern void ol_g_set_zero (double **);
extern void ol_g_set_id (double **);
extern void ol_g_set_this (double **, double, double, double, double, double,
			   double, double, double, double);
extern void ol_g_memcpy (double **, double **);
extern int ol_g_fscanf (FILE *, double **);
extern int ol_g_fprintf (FILE *, double **, char *);

#endif /* OL_G0_H */
#ifndef OL_M0_H
#define OL_M0_H

extern int* ol_m_alloc (void);
extern void ol_m_free (int *);
extern void ol_m_g (int *, double **);
extern void ol_g_m (double **, char*, int, int, int **, double *, int *);
extern void ol_g_m_quality (double **, char*, int, int, double, int **,
			    double *, int *);
extern void ol_e_m (double *, char*, int, int, int **, double *, int *);
extern void ol_e_m_quality (double *, char*, int, int, double, int **,
			    double *, int *);
extern void ol_rtheta_m (double *, double, char*, int, int, int **, double *, int *);
extern void ol_rtheta_m_quality (double *, double, char*, int, int, double, int **,
				 double *, int *);
extern void ol_R_m (double *, char*, int, int, int **, double *, int *);
extern void ol_R_m_quality (double *, char*, int, int, double, int **,
			    double *, int *);
extern void ol_q_m (double *, char*, int, int, int **, double *, int *);
extern void ol_q_m_quality (double *, char*, int, int, double, int **,
			    double *, int *);
extern void ol_m_memcpy (int *, int *);
extern int ol_m_fscanf (FILE *, int *);
extern int ol_m_fprintf (FILE *, int *, char *);
extern void ol_m_set_zero (int *);
extern void ol_m_set_id (int *);
extern void ol_m_set_this (int *, int, int, int, int, int, int);
extern void ol_m_e (int *, double *);
extern void ol_m_e_rad (int *, double *);
extern void ol_m_q (int *, double *);
extern void ol_m_rtheta (int *, double *, double *);
extern void ol_m_rtheta_rad (int *, double *, double *);
extern void ol_m_r (int *, double *);
extern void ol_m_theta (int *, double *);
extern void ol_m_theta_rad (int *, double *);
extern void ol_m_R (int *, double *);

#endif /* OL_M0_H */
#ifndef OL_POLE0_H
#define OL_POLE0_H

extern int* ol_pole_alloc (void);
extern int* ol_hpole_alloc (void);
extern double* ol_vect_alloc (void);
extern double* ol_p_alloc (void);
extern void ol_pole_free (int *);
extern void ol_hpole_free (int *);
extern void ol_vect_free (double *);
extern void ol_p_free (double *);
extern int ol_pole_fprintf (FILE *, int *, char *);
extern int ol_pole_fscanf (FILE *, int *);
extern int ol_hpole_fprintf (FILE *, int *, char *);
extern int ol_hpole_fscanf (FILE *, int *);
extern int ol_vect_fprintf (FILE *, double *, char *);
extern int ol_vect_fscanf (FILE *, double *);
extern int ol_p_fprintf (FILE *, double *, char *);
extern int ol_p_fscanf (FILE *, double *);
extern void ol_pole_vect (int *, double *);
extern void ol_hpole_vect (int *, double *);
extern void ol_vect_stproj (double *, double *);
extern void ol_vect_stproj_rad (double *, double *);
extern void ol_vect_stprojxy (double *, double *);
extern void ol_eaprojxy_vect (double *, double *);
extern void ol_vect_eaproj (double *, double *);
extern void ol_vect_eaprojxy (double *, double *);
extern void ol_vect_eaproj_rad (double *, double *);
extern void ol_g_pf_stproj (double **, double *, double *);
extern void ol_g_pf_stproj_rad (double **, double *, double *);
extern void ol_g_pf_stprojxy (double **, double *, double *);
extern void ol_g_pf_eaproj (double **, double *, double *);
extern void ol_g_pf_eaprojxy (double **, double *, double *);
extern void ol_g_pf_eaproj_rad (double **, double *, double *);
extern void ol_g_ipf_stproj (double **, double *, double *);
extern void ol_g_ipf_stproj_rad (double **, double *, double *);
extern void ol_g_ipf_stprojxy (double **, double *, double *);
extern void ol_g_ipf_eaproj (double **, double *, double *);
extern void ol_g_ipf_eaprojxy (double **, double *, double *);
extern void ol_g_ipf_eaproj_rad (double **, double *, double *);
extern void ol_g_ipf_crysym_stproj (double **, double *, char*, double *);
extern void ol_g_ipf_crysym_stproj_rad (double **, double *, char*, double *);
extern void ol_g_ipf_crysym_stprojxy (double **, double *, char*, double *);
extern void ol_g_ipf_crysym_eaproj (double **, double *, char*, double *);
extern void ol_g_ipf_crysym_eaprojxy (double **, double *, char*, double *);
extern void ol_g_ipf_crysym_eaproj_rad (double **, double *, char*, double *);

extern void ol_q_pf_stproj (double *, double *, double *);
extern void ol_q_pf_stprojxy (double *, double *, double *);
extern void ol_q_pf_stproj_rad (double *, double *, double *);
extern void ol_q_pf_eaproj (double *, double *, double *);
extern void ol_q_pf_eaprojxy (double *, double *, double *);
extern void ol_q_pf_eaproj_rad (double *, double *, double *);
extern void ol_q_ipf_stproj (double *, double *, double *);
extern void ol_q_ipf_stprojxy (double *, double *, double *);
extern void ol_q_ipf_stproj_rad (double *, double *, double *);
extern void ol_q_ipf_eaproj (double *, double *, double *);
extern void ol_q_ipf_eaprojxy (double *, double *, double *);
extern void ol_q_ipf_eaproj_rad (double *, double *, double *);
extern void ol_q_ipf_crysym_stproj (double *, double *, char*, double *);
extern void ol_q_ipf_crysym_stprojxy (double *, double *, char*, double *);
extern void ol_q_ipf_crysym_stproj_rad (double *, double *, char*, double *);
extern void ol_q_ipf_crysym_eaproj (double *, double *, char*, double *);
extern void ol_q_ipf_crysym_eaprojxy (double *, double *, char*, double *);
extern void ol_q_ipf_crysym_eaproj_rad (double *, double *, char*, double *);

extern void ol_e_pf_stproj (double *, double *, double *);
extern void ol_e_pf_stprojxy (double *, double *, double *);
extern void ol_e_pf_stproj_rad (double *, double *, double *);
extern void ol_e_pf_eaproj (double *, double *, double *);
extern void ol_e_pf_eaprojxy (double *, double *, double *);
extern void ol_e_pf_eaproj_rad (double *, double *, double *);
extern void ol_e_ipf_stproj (double *, double *, double *);
extern void ol_e_ipf_stprojxy (double *, double *, double *);
extern void ol_e_ipf_stproj_rad (double *, double *, double *);
extern void ol_e_ipf_eaproj (double *, double *, double *);
extern void ol_e_ipf_eaprojxy (double *, double *, double *);
extern void ol_e_ipf_eaproj_rad (double *, double *, double *);
extern void ol_e_ipf_crysym_stproj (double *, double *, char*, double *);
extern void ol_e_ipf_crysym_stprojxy (double *, double *, char*, double *);
extern void ol_e_ipf_crysym_stproj_rad (double *, double *, char*, double *);
extern void ol_e_ipf_crysym_eaproj (double *, double *, char*, double *);
extern void ol_e_ipf_crysym_eaprojxy (double *, double *, char*, double *);
extern void ol_e_ipf_crysym_eaproj_rad (double *, double *, char*, double *);

extern void ol_R_pf_stproj (double *, double *, double *);
extern void ol_R_pf_stprojxy (double *, double *, double *);
extern void ol_R_pf_stproj_rad (double *, double *, double *);
extern void ol_R_pf_eaproj (double *, double *, double *);
extern void ol_R_pf_eaprojxy (double *, double *, double *);
extern void ol_R_pf_eaproj_rad (double *, double *, double *);
extern void ol_R_ipf_stproj (double *, double *, double *);
extern void ol_R_ipf_stprojxy (double *, double *, double *);
extern void ol_R_ipf_stproj_rad (double *, double *, double *);
extern void ol_R_ipf_eaproj (double *, double *, double *);
extern void ol_R_ipf_eaprojxy (double *, double *, double *);
extern void ol_R_ipf_eaproj_rad (double *, double *, double *);
extern void ol_R_ipf_crysym_stproj (double *, double *, char*, double *);
extern void ol_R_ipf_crysym_stprojxy (double *, double *, char*, double *);
extern void ol_R_ipf_crysym_stproj_rad (double *, double *, char*, double *);
extern void ol_R_ipf_crysym_eaproj (double *, double *, char*, double *);
extern void ol_R_ipf_crysym_eaprojxy (double *, double *, char*, double *);
extern void ol_R_ipf_crysym_eaproj_rad (double *, double *, char*, double *);

extern void ol_pole_set_zero (int *);
extern void ol_pole_set_this (int *, int, int, int);
extern void ol_pole_memcpy (int *, int *);
extern void ol_vect_set_zero (double *);
extern void ol_vect_set_this (double *, double, double, double);
extern void ol_vect_memcpy (double *, double *);
extern void ol_p_set_zero (double *);
extern void ol_p_set_this (double *, double, double);
extern void ol_p_memcpy (double *, double *);

extern void ol_stproj_vect_rad (double *, double *);
extern void ol_eaproj_vect_rad (double *, double *);
extern void ol_stproj_vect (double *, double *);
extern void ol_eaproj_vect (double *, double *);
extern void ol_stprojxy_vect (double *, double *);
extern void ol_eaprojxy_vect (double *, double *);

extern int ol_vect_ipfweight (double *, double *);

#endif /* OL_POLE0_H */
#ifndef OL_Q0_H
#define OL_Q0_H

extern double* ol_q_alloc (void);
extern void ol_q_free (double *);
extern int ol_q_fscanf (FILE *, double *);
extern int ol_q_fprintf (FILE *, double *, char *);
extern void ol_q_rtheta (double *, double *, double *);
extern void ol_q_rtheta_rad (double *, double *, double *);
extern void ol_q_r (double *, double *);
extern void ol_q_theta (double *, double *);
extern void ol_q_theta_rad (double *, double *);
extern void ol_q_r (double *, double *);
extern void ol_q_theta (double *, double *);
extern void ol_q_theta_rad (double *, double *);
extern void ol_rtheta_q (double *, double, double *);
extern void ol_rtheta_q_rad (double *, double, double *);
extern void ol_q_R (double *, double *);
extern void ol_R_q (double *, double *);
extern void ol_g_q (double **, double *);
extern void ol_q_g (double *, double **);
extern void ol_e_q (double *, double *);
extern void ol_q_e (double *, double *);
extern void ol_e_q_rad (double *, double *);
extern void ol_q_e_rad (double *, double *);
extern void ol_q_memcpy (double *, double *);
extern void ol_q_q (double *, double *);
extern void ol_q_set_zero (double *);
extern void ol_q_set_id (double *);
extern void ol_q_set_unit (double *);
extern void ol_q_set_this (double *, double, double, double, double);

#endif /* OL_Q0_H */
#ifndef OL_RTHETA0_H
#define OL_RTHETA0_H

extern double* ol_r_alloc (void);
extern void ol_r_free (double *);
extern int ol_rtheta_fscanf (FILE *, double *, double *);
extern int ol_r_fscanf (FILE *, double *);
extern int ol_theta_fscanf (FILE *, double *);
extern int ol_rtheta_fprintf (FILE *, double *, double, char *);
extern int ol_r_fprintf (FILE *, double *, char *);
extern int ol_theta_fprintf (FILE *, double, char *);
extern int ol_r_fprintf (FILE *, double *, char *);
extern int ol_theta_fprintf (FILE *, double, char *);
extern int ol_g_rtheta (double **, double *, double *);
extern int ol_g_rtheta_rad (double **, double *, double *);
extern int ol_g_r (double **, double *);
extern void ol_g_theta (double **, double *);
extern void ol_g_theta_rad (double **, double *);
extern void ol_rtheta_g (double *, double, double **);
extern void ol_rtheta_g_rad (double *, double, double **);
extern void ol_r_memcpy (double *, double *);
extern void ol_rtheta_memcpy (double *, double, double *, double *);
extern void ol_r_set_zero (double *);
extern void ol_r_set_id (double *);
extern void ol_r_set_unit (double *);
extern void ol_r_set_this (double *, double, double, double);
extern void ol_rtheta_set_zero (double *, double *);
extern void ol_rtheta_set_id (double *, double *);
extern void ol_rtheta_set_this (double *, double *, double, double, double,
				double);
extern void ol_rtheta_rtheta (double *, double, double *, double *);
extern void ol_rtheta_rtheta_rad (double *, double, double *, double *);
extern void ol_theta_deg2rad (double, double *);
extern void ol_theta_rad2deg (double, double *);

extern void ol_rtheta_e (double *, double, double *);
extern void ol_rtheta_e_rad (double *, double, double *);

#endif /* OL_RTHETA0_H */
#endif /* OL_DESx */
