/**********************************************************************
 * Orilib - routines for orientation manipulation.                    *
 * Copyright (C) 2007, 2008, 2009 Romain Quey                         *
 *                                                                    *
 * This program is free software: you can redistribute it and/or      *
 * modify it under the terms of the GNU General Public License as     *
 * published by the Free Software Foundation, either version 3 of the *
 * License, or (at your option) any later version.                    *
 *                                                                    *
 * This program is distributed in the hope that it will be useful,    *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of     *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
 * General Public License for more details.                           *
 *                                                                    *
 * You should have received a copy of the GNU General Public License  *
 * along with this program.  If not, see                              *
 * <http://www.gnu.org/licenses/>.                                    *
 *                                                                    *
 * project homepage: http://orilib.sourceforge.net                    *
 **********************************************************************/
#ifndef OL_SETx
#define OL_SETx

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include"../ut/ut.h"
#define isNaN(x) ((x) != (x))
#ifndef STRUCTOL_SET_H
#define STRUCTOL_SET_H

struct OL_SET
{
  size_t size;
  double **q;
  double *weight;
};
typedef struct OL_SET OL_SET;

#endif /* STRUCTOL_SET_H */
#include <string.h>
#include "ol_glo.h"
#include "ol_des.h"
#include "ol_gen.h"
#ifndef OL_MEAN0_H
#define OL_MEAN0_H

extern void ol_set_mean (struct OL_SET, char*, double *);
extern void ol_set_mean_ref (struct OL_SET, char*, double *, double *);
extern int ol_set_mean_iter (struct OL_SET, char*, double *);
extern int ol_set_mean_iter_ref (struct OL_SET, char*, double *, double *);

#endif /* OL_MEAN0_H */
#ifndef OL_SET_ALLOC0_H
#define OL_SET_ALLOC0_H

extern struct OL_SET ol_set_alloc (size_t);
extern void ol_set_free (struct OL_SET);
extern int ol_set_fscanf (FILE *, struct OL_SET *, int*);
extern int ol_set_fscanf_sample (FILE *, double, struct OL_SET *, int*);
extern int ol_set_fprintf (FILE *, struct OL_SET, int, char*);
extern int ol_set_fscanf_short (FILE *, struct OL_SET *);
extern int ol_set_fscanf_sample_short (FILE *, double, struct OL_SET *);
extern int ol_set_fprintf_short (FILE *, struct OL_SET, char*);
extern void ol_set_subset (struct OL_SET, double, struct OL_SET *);
extern void ol_set_orthotropic (struct OL_SET, struct OL_SET *);
extern void ol_set_memcpy (struct OL_SET, struct OL_SET*);

#endif /* OL_SET_ALLOC0_H */
#ifndef OL_SET_DEP0_H
#define OL_SET_DEP0_H

extern void ol_set_aniso (struct OL_SET, double **, double *);
extern void ol_q_aniso_theta (double *, double **, double *);
extern void ol_set_aniso_thetadistrib (struct OL_SET, double **, double,
				       double **, double *, int *);

#endif /* OL_SET_DEP0_H */
#ifndef OL_SET_SAMPLE0_H
#define OL_SET_SAMPLE0_H

extern void ol_set_sample (struct OL_SET, double, struct OL_SET *);

#endif /* OL_SET_SAMPLE0_H */
#ifndef STRUCTOL_SET_H
#define STRUCTOL_SET_H

struct OL_SET
{
  size_t size;
  double **q;
  double *weight;
};
typedef struct OL_SET OL_SET;

#endif /* STRUCTOL_SET_H */
#ifndef OL_SPREAD0_H
#define OL_SPREAD0_H

extern void ol_set_disori (struct OL_SET, char*, double *, double *);
extern int ol_set_filter (struct OL_SET, char*, double, struct OL_SET *, double*, double*);
extern int ol_set_filter_iter (struct OL_SET, char*, double, struct OL_SET *, double*, double*);
extern int ol_set_anifilter (struct OL_SET, char*, double, struct OL_SET *);
extern int ol_set_anifilter_iter (struct OL_SET, char*, double, struct OL_SET *, double*, double**, double*, struct OL_SET*);
extern int ol_set_anifilter_iter_itermax (struct OL_SET, char*, double, int, struct OL_SET *, double*, double**, double*, struct OL_SET*);
extern int ol_set_mean_aniso_anifilter_iter_itermax (struct OL_SET, double*, double**, double*, char*, double, int, struct OL_SET *, double*, double**, double*, struct OL_SET*);
extern int ol_set_mean_anifilter (struct OL_SET, double*, char*, double, struct OL_SET*);
extern int ol_set_mean_aniso_anifilter (struct OL_SET, double*, double**, double*, char*, double, struct OL_SET*, struct OL_SET*);

extern void ol_set_disoriset (struct OL_SET, char*, struct OL_SET*);
extern void ol_set_mean_disoriset (struct OL_SET, double*, char*, struct OL_SET*);

extern int ol_set_mean_aniso_anifilter_iter (struct OL_SET, double*,
    double**, double*, char*, double, struct OL_SET *, double*,
    double**, double*, struct OL_SET*);

extern void ol_set_aniso_modes (struct OL_SET, double*, struct OL_SET*, struct OL_SET*);
extern void ol_set_aniso_v_modes (struct OL_SET, double*, double**, struct OL_SET*, struct OL_SET*);
extern void ol_set_aniso_v_thetatr_modes (struct OL_SET, double*, double**,
	        double, struct OL_SET*, struct OL_SET*);
extern void ol_set_aniso_v_thetatr_modes_id (struct OL_SET, double*,
					     double**, double, int*);

#endif /* OL_SPREAD0_H */
#endif /* OL_SETx */
